/*
*	interp.c - библиотека средств модификации рефал-машины в процессе работы.
*	© 2005, А.А.Владимиров.
*
*	Данная программа является свободным программным обеспечением.
*	Вы вправе распространять ее и/или модифицировать в соответствии
*	с условиями версии 2, либо, по вашему выбору, с условиями
*	более поздней версии Стандартной Общественной Лицензии GNU,
*	опубликованной Free Software Foundation.
*
*	Мы распространяем данную программу в надежде на то, что она будет вам
*	полезной, однако НЕ ПРЕДОСТАВЛЯЕМ НА НЕЕ НИКАКИХ ГАРАНТИЙ, в том числе
*	ГАРАНТИИ ТОВАРНОГО СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ ИСПОЛЬЗОВАНИЯ
*	В КОНКРЕТНЫХ ЦЕЛЯХ. Для получения более подробной информации ознакомьтесь
*	со Стандартной Общественной Лицензией GNU.
*
*	Вместе с данной программой вы должны были получить экземпляр
*	Стандартной Общественной Лицензии GNU. Если вы его не получили,
*	сообщите об этом в
*	
*	Free Software Foundation, Inc.,
*	59 Temple Place, Suite 330,
*	Boston, MA 02111-1307
*	USA
*
*/

# include "refal.h"


void int_sxargi (void) __attribute__ ((constructor));


void int_interp (void);


/* ========================================================================== */


extern void ref_eraro (int);
extern void interp_krei_masxinon (char*);
extern void interp_aldoni_enkonstruitan (char* nomo, void (*funk) (void));
extern void baz_krei_linion (char*);
extern void baz_krei_bajtojn (char*);
extern unsigned long baz_preni_literon (char*, int*);
extern unsigned long baz_preni_bajton (char*, int*);


/* ========================================================================== */

void int_sxargi () {
	
	interp_aldoni_enkonstruitan ("interp", int_interp);
	return;
}

/* ========================================================================== */


/*
*	Функция "int_interp" запускает процесс интерпретации файла, имя которого
*	заключено между KKK и KKP.
*
*/

void int_interp () {
	char *titolo;
	
	titolo = (char *) malloc (sizeof (char) * LIN_LIM);
	if (titolo == NULL) ref_eraro (1);
	baz_krei_linion (titolo);
	if (KKK->sekv != KKP) ref_eraro (8);
	interp_krei_masxinon (titolo);
	return;
}

