/*
*	interpretilo.c - наиболее общие функции интерпретатора.
*	© 2005, А.А.Владимиров.
*
*	Данная программа является свободным программным обеспечением.
*	Вы вправе распространять ее и/или модифицировать в соответствии
*	с условиями версии 2, либо, по вашему выбору, с условиями
*	более поздней версии Стандартной Общественной Лицензии GNU,
*	опубликованной Free Software Foundation.
*
*	Мы распространяем данную программу в надежде на то, что она будет вам
*	полезной, однако НЕ ПРЕДОСТАВЛЯЕМ НА НЕЕ НИКАКИХ ГАРАНТИЙ, в том числе
*	ГАРАНТИИ ТОВАРНОГО СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ ИСПОЛЬЗОВАНИЯ
*	В КОНКРЕТНЫХ ЦЕЛЯХ. Для получения более подробной информации ознакомьтесь
*	со Стандартной Общественной Лицензией GNU.
*
*	Вместе с данной программой вы должны были получить экземпляр
*	Стандартной Общественной Лицензии GNU. Если вы его не получили,
*	сообщите об этом в
*	
*	Free Software Foundation, Inc.,
*	59 Temple Place, Suite 330,
*	Boston, MA 02111-1307
*	USA
*
*/

# include "refal.h"
# include <string.h>
# include <dlfcn.h>
# include <libintl.h>


unsigned int linnum = 0;
char *dosiero;


void interp_krei_masxinon (char*);
void interp_eraro (int);


int interp_legi (char*, char*, FILE*);


/* ========================================================================== */


extern void ref_eraro (int);
extern void interp_aldoni_funkcion (char*, int*);
extern void interp_aldoni_substituon (char*, int*);
extern unsigned long *interp_preni_nomon (char*, int*);
extern void interp_preteriri_spacetojn (char*, int*);


/* ========================================================================== */


/*
*	Функция "interp_krei_masxinon" конструирует набор функций рефал-машины,
*	описанный в файле с именем "titolo".
*
*/

void interp_krei_masxinon (char *titolo) {
	int i, pozicio;
	unsigned int linnum_lok;
	unsigned long *l;
	char *linio, *bufro, *eraro;
	FILE *programo;

	linnum_lok = 0;
	linio = (char *) malloc (sizeof (char) * LIN_LIM);
	bufro = (char *) malloc (sizeof (char) * LIN_LIM);
	if ((linio == NULL) || (bufro == NULL)) ref_eraro (1);
	programo = fopen (titolo, "r");
	if (programo == NULL) interp_eraro (13);
	dosiero = titolo;
	KFS = NULL;
	while (1) {
		linnum = linnum_lok;
		i = interp_legi (linio, bufro, programo);
		linnum_lok = linnum;
		pozicio = 0;
		switch (i) {
			case 0:
				switch (linio [0]) {
					case '\0':
					case '#':
						break;
					
					case '\t':
					case ' ':
						interp_preteriri_spacetojn (linio, &pozicio);
						if (linio [pozicio] != '\0') {
							if (KFS == NULL) interp_eraro (6);
							KFS->sekv = (SUBSTITUO *) malloc
								(sizeof (SUBSTITUO));
							if (KFS->sekv == NULL) ref_eraro (1);
							KFS = KFS->sekv;
							KFS->sekv = NULL;
							interp_aldoni_substituon (linio, &pozicio);
						};
						break;
					
					case '$':
						pozicio ++;
						l = interp_preni_nomon (linio, &pozicio);
/* $include */				if ((l [0] == 105) && (l [1] == 110) &&
						(l [2] == 99) && (l [3] == 108) &&
						(l [4] == 117) && (l [5] == 100) &&
						(l [6] == 101) && (l [7] == 0)) {
							interp_preteriri_spacetojn (linio, &pozicio);
							if (linio [pozicio] != '\'') {
								interp_eraro (7);
							};
							i = 0;
							pozicio ++;
							while (linio [pozicio] != '\'') {
								if (linio [pozicio] == '\0') {
									interp_eraro (7);
								};
								bufro [i] = linio [pozicio];
								i ++;
								pozicio ++;
							};
							bufro [i] = '\0';
							pozicio ++;
							interp_preteriri_spacetojn (linio, &pozicio);
							if (linio [pozicio] != '\0') {
								interp_eraro (7);
							};
							interp_krei_masxinon (bufro);
							dosiero = titolo;
						}
						else {
/* $use */					if ((l [0] == 117) && (l [1] == 115) &&
							(l [2] == 101) && (l [3] == 0)){
								interp_preteriri_spacetojn
									(linio, &pozicio);
								if (linio [pozicio] != '\'') {
									interp_eraro (7);
								};
								pozicio ++;
								bufro = strcpy (bufro, BIB_DOSIERUJO);
								i = strlen (bufro);
								while ((linio [pozicio] != '\'') &&
								(i < LIN_LIM - BIB_SUFIKSA_LONGO)) {
									if (linio [pozicio] == '\0') {
										interp_eraro (7);
									};
									bufro [i] = linio [pozicio];
									i ++;
									pozicio ++;
								};
								if (linio [pozicio] != '\'') {
									interp_eraro (1);
								};
								bufro [i] = '\0';
								strcat (bufro, BIB_SUFIKSO);
								pozicio ++;
								interp_preteriri_spacetojn
									(linio, &pozicio);
								if (linio [pozicio] != '\0') {
									interp_eraro (7);
								};
								dlopen (bufro, RTLD_LAZY);
								eraro = dlerror ();
								if (eraro != NULL) {
									fprintf (stderr, "%s\n", eraro);
									exit (1);
								};
							}
							else {
/* $start */						if ((l [0] == 115) && (l [1] == 116) &&
								(l [2] == 97) && (l [3] == 114) &&
								(l [4] == 116) && (l [5] == 0)) {
									(LF->sekv)->dat.s =
										(SUBSTITUO *) malloc
										(sizeof (SUBSTITUO));
									if ((LF->sekv)->dat.s == NULL) {
										ref_eraro (1);
									};
									KFS = (LF->sekv)->dat.s;
									KFS->sekv = NULL;
									interp_preteriri_spacetojn
										(linio, &pozicio);
									pozicio --;
									linio [pozicio] = '=';
									interp_aldoni_substituon
										(linio, &pozicio);
									KFS = NULL;
								}
								else {
									interp_eraro (7);
								};
							};
						};
						free (l);
						break;
					
					default:
						interp_aldoni_funkcion (linio, &pozicio);
						break;
				};
				break;
				
			case 1:
				interp_eraro (1);
				break;
			
			case 2:
				fclose (programo);
				return;
				break;
		};
	};
	return;
}


/*
*	Функция "interp_eraro" генерирует сообщения об ошибках интерпретации.
*
*/

void interp_eraro (int ern) {

	switch (ern) {
		case 1:
			fprintf (stderr, "\n%s %s, %s %d: %s.\n",
			gettext ("Dosiero"), dosiero, gettext ("linio"), linnum,
			gettext ("tro longa linio"));
			break;
		
		case 2:
			fprintf (stderr, "\n%s %s, %s %d: %s.\n",
			gettext ("Dosiero"), dosiero, gettext ("linio"), linnum,
			gettext ("tro longa nomo de objekto"));
			break;
		
		case 3:
			fprintf (stderr, "\n%s %s, %s %d: %s.\n",
			gettext ("Dosiero"), dosiero, gettext ("linio"), linnum,
			gettext ("troa dekstra struktura parentezo"));
			break;
		
		case 4:
			fprintf (stderr, "\n%s %s, %s %d: %s.\n",
			gettext ("Dosiero"), dosiero, gettext ("linio"), linnum,
			gettext ("troa maldekstra struktura parentezo, aŭ konkretigo"));
			break;

		case 5:
			fprintf (stderr, "\n%s %s, %s %d: %s.\n",
			gettext ("Dosiero"), dosiero, gettext ("linio"), linnum,
			gettext ("troa konkretiganta punkto"));
			break;
		
		case 6:
			fprintf (stderr, "\n%s %s, %s %d: %s.\n",
			gettext ("Dosiero"), dosiero, gettext ("linio"), linnum,
			gettext ("sendeterminata funkcio"));
			break;
		
		case 7:
			fprintf (stderr, "\n%s %s, %s %d: %s.\n",
			gettext ("Dosiero"), dosiero, gettext ("linio"), linnum,
			gettext ("malbona $-operatoro"));
			break;
		
		case 8:
			fprintf (stderr, "\n%s %s, %s %d: %s.\n",
			gettext ("Dosiero"), dosiero, gettext ("linio"), linnum,
			gettext ("malbona sekvenco de UTF-8"));
			break;
		
		case 9:
			fprintf (stderr, "\n%s %s, %s %d: %s.\n",
			gettext ("Dosiero"), dosiero, gettext ("linio"), linnum,
			gettext ("malbona nomo de objekto"));
			break;

		case 10:
			fprintf (stderr, "\n%s %s, %s %d: %s.\n",
			gettext ("Dosiero"), dosiero, gettext ("linio"), linnum,
			gettext ("malbona determino de objekto"));
			break;

		case 11:
			fprintf (stderr, "\n%s %s, %s %d: %s.\n",
			gettext ("Dosiero"), dosiero, gettext ("linio"), linnum,
			gettext ("kolizio de variabloj"));
			break;

		case 12:
			fprintf (stderr, "\n%s %s, %s %d: %s.\n",
			gettext ("Dosiero"), dosiero, gettext ("linio"), linnum,
			gettext ("uzo sendeterminan variablon"));
			break;

		case 13:
			fprintf (stderr, "\n%s %s, %s %d: %s.\n",
			gettext ("Dosiero"), dosiero, gettext ("linio"), linnum,
			gettext ("malbona dosiernomo"));
			break;
		
		default:
			fprintf (stderr, "\n%s %s, %s %d: %s.\n",
			gettext ("Dosiero"), dosiero, gettext ("linio"), linnum,
			gettext ("nerekonita eraro"));
			break;
	};
	exit (0);
	return;
}


/* ========================================================================== */


/*
*	Функция "interp_legi" считывает строку из файла "programo". Если последний
*	символ строки есть "\", то следующая строка рассматривается как продолжение
*	текущей и также считывается (при этом символ "\" из исходной строки
*	удаляется). Считанные строки записываются в массив "linio".
*	
*	В случае успеха считываения возвращаемым значением функции является 0.
*	В случае, если считываемая строка является недопустимо длинной,
*	возвращаемым значением является 1. Наконец, если считывание невозможно
*	(например, вследствии конца файла), возвращаемым значением является 2.
*
*/

int interp_legi (char *linio, char *bufro, FILE *programo) {
	int i, j;
	
	linio [0] = '\0';
	do {
		bufro = fgets (bufro, LIN_LIM, programo);
		if (bufro == NULL) return 2;
		linnum ++;
		if (strlen (linio) + strlen (bufro) >= LIN_LIM) return 1;
		strcat (linio, bufro);
		i = strlen (linio);
		j = 1;
		while (j) {
			switch (linio [i - 1]) {
				case 10:
				case 13:
					linio [i - 1] = '\0';
					i --;
					break;
				
				case 92:
					linio [i - 1] = '\0';
					i = 1;
					j = 0;
					break;
				
				default:
					i = 0;
					j = 0;
					break;
			};
		};
	} while (i);
	return 0;
}



