/*
*	interpretilo1.c - подробное определение интерпретатора.
*	© 2005, А.А.Владимиров.
*
*	Данная программа является свободным программным обеспечением.
*	Вы вправе распространять ее и/или модифицировать в соответствии
*	с условиями версии 2, либо, по вашему выбору, с условиями
*	более поздней версии Стандартной Общественной Лицензии GNU,
*	опубликованной Free Software Foundation.
*
*	Мы распространяем данную программу в надежде на то, что она будет вам
*	полезной, однако НЕ ПРЕДОСТАВЛЯЕМ НА НЕЕ НИКАКИХ ГАРАНТИЙ, в том числе
*	ГАРАНТИИ ТОВАРНОГО СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ ИСПОЛЬЗОВАНИЯ
*	В КОНКРЕТНЫХ ЦЕЛЯХ. Для получения более подробной информации ознакомьтесь
*	со Стандартной Общественной Лицензией GNU.
*
*	Вместе с данной программой вы должны были получить экземпляр
*	Стандартной Общественной Лицензии GNU. Если вы его не получили,
*	сообщите об этом в
*	
*	Free Software Foundation, Inc.,
*	59 Temple Place, Suite 330,
*	Boston, MA 02111-1307
*	USA
*
*/

# include "refal.h"


void interp_aldoni_funkcion (char*, int*);
void interp_aldoni_substituon (char*, int*);
unsigned long interp_preni_literon (char*, int*);
unsigned long *interp_preni_nomon (char*, int*);
void interp_preteriri_spacetojn (char*, int*);
int interp_kompari_nomojn (unsigned long*, unsigned long*);
void interp_preni_nombron (char*, int*, LITERO*);
void interp_sercxi_duonagemajn (void);
void interp_detrui_funkcion (FUNKCIO*);


/* ========================================================================== */


extern void ref_eraro (int);
extern void interp_eraro (int);


/* ========================================================================== */


/*
*	Функция "interp_aldoni_funkcion" запускает процесс определения функции,
*	имя которой содержится в строке "linio" (начиная с позиции "*pozicio").
*
*/

void interp_aldoni_funkcion (char *linio, int *pozicio) {
	int i;
	unsigned long *nomo;
	FUNKCIO *f;

	nomo = interp_preni_nomon (linio, pozicio);
	f = LF;
	do {
		f = f->sekv;
		i = interp_kompari_nomojn (nomo, f->nom);
	} while (!i && (f->sekv != NULL));
	if (i) {
		interp_detrui_funkcion (f);
		free (nomo);
	}
	else {
		f->sekv = (FUNKCIO *) malloc (sizeof (FUNKCIO));
		if (f->sekv == NULL) ref_eraro (1);
		f = f->sekv;
		f->nom = nomo;
		f->sekv = NULL;
	};
	f->enk = 0;
	f->dat.s = (SUBSTITUO *) malloc (sizeof (SUBSTITUO));
	if (f->dat.s == NULL) ref_eraro (1);
	KFS = f->dat.s;
	KFS->sekv = NULL;
	interp_preteriri_spacetojn (linio, pozicio);
	if (linio [*pozicio] == '\0') interp_eraro (10);
	interp_aldoni_substituon (linio, pozicio);
	return;
}


/*
*	Функция "interp_aldoni_substituon" добавляет по адресу KFS
*	формулу подстановки, описанную в строке "linio"
*	(начиная с позиции "*pozicio").
*	
*	Если строка "linio" содержит лишь пробелы и символы табуляции,
*	она игнорируется.
*
*/

void interp_aldoni_substituon (char *linio, int *pozicio) {
	int i, j, parnum = 0, k = 0, k1, m = 1;
	unsigned long l;
	unsigned long **nomv;
	unsigned long *nomf;
	LITERO *kuranta, *kuranta1;
	VARIABLO **v;
	FUNKCIO *f;
	
	nomv = (unsigned long **) malloc (sizeof (unsigned long *) * VAR_LIM);
	v = (VARIABLO **) malloc (sizeof (VARIABLO *) * VAR_LIM);
	if ((nomv == NULL) || (v == NULL)) ref_eraro (1);
	krei_literon (kuranta);
	krei_literon (kuranta->sekv);
	(kuranta->sekv)->ant = kuranta;
	kuranta->tip = KONK_K;
	KFS->mod = kuranta;
	kuranta = kuranta->sekv;
	interp_preteriri_spacetojn (linio, pozicio);
	do {
		l = interp_preni_literon (linio, pozicio);
		switch (l) {
/* ( */		case 40:
				parnum ++;
				kuranta->tip = MD_STR_PARENT;
				kuranta->dat.dual = NULL;
				krei_literon (kuranta->sekv);
				(kuranta->sekv)->ant = kuranta;
				kuranta = kuranta->sekv;
				interp_preteriri_spacetojn (linio, pozicio);
				break;
			
/* ) */		case 41:
				parnum --;
				kuranta->tip = D_STR_PARENT;
				kuranta1 = kuranta;
				i = 1;
				do {
					kuranta1 = kuranta1->ant;
					switch (kuranta1->tip) {
						case MD_LIT_PARENT:
						case KONK_K:
							interp_eraro (3);
							i = 1;
							break;
						
						case D_LIT_PARENT:
						case D_STR_PARENT:
							kuranta1 = kuranta1->dat.dual;
							i = 1;
							break;
						
						case MD_STR_PARENT:
							i = 0;
							break;
					};
				} while (i);
				ligi_parentezojn (kuranta1, kuranta);
				krei_literon (kuranta->sekv);
				(kuranta->sekv)->ant = kuranta;
				kuranta = kuranta->sekv;
				interp_preteriri_spacetojn (linio, pozicio);
				break;
			
/* s */		case 115:
				l = interp_preni_literon (linio, pozicio);
				if (l != 47) interp_eraro (9);
				nomv [k] = interp_preni_nomon (linio, pozicio);
				l = interp_preni_literon (linio, pozicio);
				if (l != 47) interp_eraro (9);
				v [k] = (VARIABLO *) malloc (sizeof (VARIABLO));
				if (v [k] == NULL) ref_eraro (1);
				j = -1;
				do {
					j ++;
					i = interp_kompari_nomojn (nomv [j], nomv [k]);
				} while (!i);
				if (j != k) {
					if (!ESTAS_S_AGEM (v [j])) interp_eraro (11);
					(v [k])->tip = S_MALAGEM;
					(v [k])->ref = v [j];
				}
				else {
					(v [k])->tip = S_AGEM;
				};
				kuranta->tip = VAR;
				kuranta->dat.var = v [k];
				krei_literon (kuranta->sekv);
				(kuranta->sekv)->ant = kuranta;
				kuranta = kuranta->sekv;
				k ++;
				interp_preteriri_spacetojn (linio, pozicio);
				break;
			
/* w */		case 119:
				l = interp_preni_literon (linio, pozicio);
				if (l != 47) interp_eraro (9);
				nomv [k] = interp_preni_nomon (linio, pozicio);
				l = interp_preni_literon (linio, pozicio);
				if (l != 47) interp_eraro (9);
				v [k] = (VARIABLO *) malloc (sizeof (VARIABLO));
				if (v [k] == NULL) ref_eraro (1);
				j = -1;
				do {
					j ++;
					i = interp_kompari_nomojn (nomv [j], nomv [k]);
				} while (!i);
				if (j != k) {
					if (!ESTAS_W_AGEM (v [j])) interp_eraro (11);
					(v [k])->tip = W_MALAGEM;
					(v [k])->ref = v [j];
				}
				else {
					(v [k])->tip = W_AGEM;
				};
				kuranta->tip = VAR;
				kuranta->dat.var = v [k];
				krei_literon (kuranta->sekv);
				(kuranta->sekv)->ant = kuranta;
				kuranta = kuranta->sekv;
				k ++;
				interp_preteriri_spacetojn (linio, pozicio);
				break;
			
/* e */		case 101:
				l = interp_preni_literon (linio, pozicio);
				if (l != 47) interp_eraro (9);
				nomv [k] = interp_preni_nomon (linio, pozicio);
				l = interp_preni_literon (linio, pozicio);
				if (l != 47) interp_eraro (9);
				v [k] = (VARIABLO *) malloc (sizeof (VARIABLO));
				if (v [k] == NULL) ref_eraro (1);
				j = -1;
				do {
					j ++;
					i = interp_kompari_nomojn (nomv [j], nomv [k]);
				} while (!i);
				if (j != k) {
					if (!ESTAS_E_AGEM (v [j])) interp_eraro (11);
					(v [k])->tip = E_MALAGEM;
					(v [k])->ref = v [j];
				}
				else {
					(v [k])->tip = E_AGEM;
				};
				kuranta->tip = VAR;
				kuranta->dat.var = v [k];
				krei_literon (kuranta->sekv);
				(kuranta->sekv)->ant = kuranta;
				kuranta = kuranta->sekv;
				k ++;
				interp_preteriri_spacetojn (linio, pozicio);
				break;
			
/* 0 - 9 */	case 48:
			case 49:
			case 50:
			case 51:
			case 52:
			case 53:
			case 54:
			case 55:
			case 56:
			case 57:
				kuranta->tip = MD_LIT_PARENT;
				krei_literon (kuranta1);
				ligi_literojn (kuranta, kuranta1);
				kuranta1->tip = CIFER;
				kuranta1->dat.cif = (unsigned int)(l - 48);
				krei_literon (kuranta);
				ligi_literojn (kuranta1, kuranta);
				kuranta->tip = D_LIT_PARENT;
				ligi_parentezojn (kuranta1->ant, kuranta);
				interp_preni_nombron (linio, pozicio, kuranta1);
				krei_literon (kuranta->sekv);
				(kuranta->sekv)->ant = kuranta;
				kuranta = kuranta->sekv;
				interp_preteriri_spacetojn (linio, pozicio);
				break;
			
/* ' */		case 39:
				do {
					l = interp_preni_literon (linio, pozicio);
					if (l == 0) interp_eraro (10);
					if (l == 39) {
						i = 0;
					}
					else {
						i = 1;
						kuranta->tip = MD_LIT_PARENT;
						krei_literon (kuranta->dat.dual);
						(kuranta->dat.dual)->tip = D_LIT_PARENT;
						(kuranta->dat.dual)->dat.dual = kuranta;
						krei_literon (kuranta1);
						ligi_literojn (kuranta, kuranta1);
						kuranta1->tip = CIFER;
						kuranta1->dat.cif = (unsigned int) (l % 65536);
						l /= 65536;
						if (l != 0) {
							krei_literon (kuranta1->sekv);
							(kuranta1->sekv)->ant = kuranta1;
							kuranta1 = kuranta1->sekv;
							kuranta1->tip = CIFER;
							kuranta1->dat.cif = (unsigned int) l;
						};
						ligi_literojn (kuranta1, kuranta->dat.dual);
						krei_literon (kuranta);
						ligi_literojn (kuranta1->sekv, kuranta);
					};
				} while (i);
				interp_preteriri_spacetojn (linio, pozicio);
				break;
			
/* = */		case 61:
				if (parnum != 0) interp_eraro (4);
				kuranta->tip = KONK_P;
				ligi_parentezojn (KFS->mod, kuranta);
				interp_sercxi_duonagemajn ();
				m = 0;
				break;
			
			default:
				interp_eraro (10);
				break;
		};
	} while (m);
	m = 1;
	k1 = k;
	krei_literon (kuranta);
	kuranta->ant = NULL;
	KFS->rez = kuranta;
	interp_preteriri_spacetojn (linio, pozicio);
	do {
		l = interp_preni_literon (linio, pozicio);
		switch (l) {
/* ( */		case 40:
				parnum ++;
				kuranta->tip = MD_STR_PARENT;
				krei_literon (kuranta->sekv);
				(kuranta->sekv)->ant = kuranta;
				kuranta = kuranta->sekv;
				interp_preteriri_spacetojn (linio, pozicio);
				break;
			
/* ) */		case 41:
				parnum --;
				kuranta->tip = D_STR_PARENT;
				kuranta1 = kuranta;
				i = 1;
				do {
					if (kuranta1->ant == NULL) interp_eraro (3);
					kuranta1 = kuranta1->ant;
					switch (kuranta1->tip) {
						case MD_LIT_PARENT:
						case KONK_K:
							interp_eraro (3);
							i = 1;
							break;
						
						case D_LIT_PARENT:
						case D_STR_PARENT:
						case KONK_P:
							kuranta1 = kuranta1->dat.dual;
							i = 1;
							break;
						
						case MD_STR_PARENT:
							i = 0;
							break;
					};
				} while (i);
				ligi_parentezojn (kuranta1, kuranta);
				krei_literon (kuranta->sekv);
				(kuranta->sekv)->ant = kuranta;
				kuranta = kuranta->sekv;
				interp_preteriri_spacetojn (linio, pozicio);
				break;
			
/* k */		case 107:
				parnum ++;
				l = interp_preni_literon (linio, pozicio);
				if (l != 47) interp_eraro (9);
				nomf = interp_preni_nomon (linio, pozicio);
				l = interp_preni_literon (linio, pozicio);
				if (l != 47) interp_eraro (9);
				f = LF;
				j = 0;
				do {
					f = f->sekv;
					j ++;
					i = interp_kompari_nomojn (nomf, f->nom);
				} while (!i && (f->sekv != NULL));
				if (i) {
					free (nomf);
				}
				else {
					f->sekv = (FUNKCIO *) malloc (sizeof (FUNKCIO));
					if (f->sekv == NULL) ref_eraro (1);
					f = f->sekv;
					f->sekv = NULL;
					f->nom = nomf;
					f->enk = 0;
					f->dat.s = NULL;
				};
				kuranta->tip = KONK_K;
				kuranta->dat.funk = f;
				krei_literon (kuranta->sekv);
				(kuranta->sekv)->ant = kuranta;
				kuranta = kuranta->sekv;
				interp_preteriri_spacetojn (linio, pozicio);
				break;
			
/* . */		case 46:
				parnum --;
				kuranta->tip = KONK_P;
				kuranta1 = kuranta;
				i = 1;
				do {
					if (kuranta1->ant == NULL) interp_eraro (5);
					kuranta1 = kuranta1->ant;
					switch (kuranta1->tip) {
						case MD_LIT_PARENT:
						case MD_STR_PARENT:
							interp_eraro (5);
							i = 1;
							break;
						
						case D_LIT_PARENT:
						case D_STR_PARENT:
						case KONK_P:
							kuranta1 = kuranta1->dat.dual;
							i = 1;
							break;
						
						case KONK_K:
							i = 0;
							break;
					};
				} while (i);
				kuranta->dat.dual = kuranta1;
				krei_literon (kuranta->sekv);
				(kuranta->sekv)->ant = kuranta;
				kuranta = kuranta->sekv;
				interp_preteriri_spacetojn (linio, pozicio);
				break;
			
/* s */		case 115:
				l = interp_preni_literon (linio, pozicio);
				if (l != 47) interp_eraro (9);
				nomv [k] = interp_preni_nomon (linio, pozicio);
				l = interp_preni_literon (linio, pozicio);
				if (l != 47) interp_eraro (9);
				v [k] = (VARIABLO *) malloc (sizeof (VARIABLO));
				if (v [k] == NULL) ref_eraro (1);
				j = -1;
				do {
					j ++;
					i = interp_kompari_nomojn (nomv [j], nomv [k]);
				} while (!i);
				if (j == k) interp_eraro (12);
				if (!ESTAS_S_AGEM (v [j]) && !ESTAS_S_MALAGEM (v [j])) {
					interp_eraro (11);
				}
				if (j < k1) {
					(v [k])->tip = S_MALAGEM;
					(v [k])->ref = v [j];
					nomv [j] [0] = 0;
				}
				else {
					(v [k])->tip = S_AGEM;
					(v [k])->ref = (v [j])->ref;
				};
				kuranta->tip = VAR;
				kuranta->dat.var = v [k];
				krei_literon (kuranta->sekv);
				(kuranta->sekv)->ant = kuranta;
				kuranta = kuranta->sekv;
				k ++;
				interp_preteriri_spacetojn (linio, pozicio);
				break;
			
/* w */		case 119:
				l = interp_preni_literon (linio, pozicio);
				if (l != 47) interp_eraro (9);
				nomv [k] = interp_preni_nomon (linio, pozicio);
				l = interp_preni_literon (linio, pozicio);
				if (l != 47) interp_eraro (9);
				v [k] = (VARIABLO *) malloc (sizeof (VARIABLO));
				if (v [k] == NULL) ref_eraro (1);
				j = -1;
				do {
					j ++;
					i = interp_kompari_nomojn (nomv [j], nomv [k]);
				} while (!i);
				if (j == k) interp_eraro (12);
				if (!ESTAS_W_AGEM (v [j]) && !ESTAS_W_MALAGEM (v [j])) {
					interp_eraro (11);
				}
				if (j < k1) {
					(v [k])->tip = W_MALAGEM;
					(v [k])->ref = v [j];
					nomv [j] [0] = 0;
				}
				else {
					(v [k])->tip = W_AGEM;
					(v [k])->ref = (v [j])->ref;
				};
				kuranta->tip = VAR;
				kuranta->dat.var = v [k];
				krei_literon (kuranta->sekv);
				(kuranta->sekv)->ant = kuranta;
				kuranta = kuranta->sekv;
				k ++;
				interp_preteriri_spacetojn (linio, pozicio);
				break;
			
/* e */		case 101:
				l = interp_preni_literon (linio, pozicio);
				if (l != 47) interp_eraro (9);
				nomv [k] = interp_preni_nomon (linio, pozicio);
				l = interp_preni_literon (linio, pozicio);
				if (l != 47) interp_eraro (9);
				v [k] = (VARIABLO *) malloc (sizeof (VARIABLO));
				if (v [k] == NULL) ref_eraro (1);
				j = -1;
				do {
					j ++;
					i = interp_kompari_nomojn (nomv [j], nomv [k]);
				} while (!i);
				if (j == k) interp_eraro (12);
				if (!ESTAS_E_AGEM (v [j]) && !ESTAS_E_DUONAGEM (v [j]) &&
				!ESTAS_E_MALAGEM (v [j])) interp_eraro (11);
				if (j < k1) {
					(v [k])->tip = E_MALAGEM;
					(v [k])->ref = v [j];
					nomv [j] [0] = 0;
				}
				else {
					(v [k])->tip = E_AGEM;
					(v [k])->ref = (v [j])->ref;
				};
				kuranta->tip = VAR;
				kuranta->dat.var = v [k];
				krei_literon (kuranta->sekv);
				(kuranta->sekv)->ant = kuranta;
				kuranta = kuranta->sekv;
				k ++;
				interp_preteriri_spacetojn (linio, pozicio);
				break;
			
/* 0 - 9 */	case 48:
			case 49:
			case 50:
			case 51:
			case 52:
			case 53:
			case 54:
			case 55:
			case 56:
			case 57:
				kuranta->tip = MD_LIT_PARENT;
				krei_literon (kuranta1);
				ligi_literojn (kuranta, kuranta1);
				kuranta1->tip = CIFER;
				kuranta1->dat.cif = (unsigned int)(l - 48);
				krei_literon (kuranta);
				ligi_literojn (kuranta1, kuranta);
				kuranta->tip = D_LIT_PARENT;
				ligi_parentezojn (kuranta1->ant, kuranta);
				interp_preni_nombron (linio, pozicio, kuranta1);
				krei_literon (kuranta->sekv);
				(kuranta->sekv)->ant = kuranta;
				kuranta = kuranta->sekv;
				interp_preteriri_spacetojn (linio, pozicio);
				break;
			
/* ' */		case 39:
				do {
					l = interp_preni_literon (linio, pozicio);
					if (l == 0) interp_eraro (10);
					if (l == 39) {
						i = 0;
					}
					else {
						i = 1;
						kuranta->tip = MD_LIT_PARENT;
						krei_literon (kuranta->dat.dual);
						(kuranta->dat.dual)->tip = D_LIT_PARENT;
						(kuranta->dat.dual)->dat.dual = kuranta;
						krei_literon (kuranta1);
						ligi_literojn (kuranta, kuranta1);
						kuranta1->tip = CIFER;
						kuranta1->dat.cif = (unsigned int) (l % 65536);
						l /= 65536;
						if (l != 0) {
							krei_literon (kuranta1->sekv);
							(kuranta1->sekv)->ant = kuranta1;
							kuranta1 = kuranta1->sekv;
							kuranta1->tip = CIFER;
							kuranta1->dat.cif = (unsigned int) l;
						};
						ligi_literojn (kuranta1, kuranta->dat.dual);
						krei_literon (kuranta);
						ligi_literojn (kuranta1->sekv, kuranta);
					};
				} while (i);
				interp_preteriri_spacetojn (linio, pozicio);
				break;
			
			case 0:
				if (parnum != 0) interp_eraro (4);
				if (kuranta->ant != NULL) {
					(kuranta->ant)->sekv = NULL;
				}
				else {
					KFS->rez = NULL;
				};
				detrui_literon (kuranta);
				m = 0;
				break;
			
			default:
				interp_eraro (10);
				break;
		};
	} while (m);
	for (j = 0; j < k; j ++) {
		free (nomv [j]);
	};
	free (nomv);
	free (v);
	return;
}


/*
*	Функция "interp_preni_literon" считывает букву (в кодировке UTF-8),
*	записанную в строке "linio", начиная с позиции "*pozicio".
*	
*	Возвращаемым значением функции является число типа (unsigned long),
*	представляющее собой номер считанной буквы в таблице юникода.
*	
*	По окончании работы функции значением параметра "*pozicio" является
*	номер позиции, непосредственно следующей за считанной буквой.
*
*/

unsigned long interp_preni_literon (char *linio, int *pozicio) {
	int k;
	unsigned long l;
	
	if ((linio [*pozicio]) >> 7 == 0) {
		k = *pozicio;
		(*pozicio) ++;
		return (unsigned long) (linio [k]);
	};
	if (((linio [*pozicio]) >> 6 == 2) || ((linio [*pozicio]) == 254) ||
	((linio [*pozicio]) == 255)) interp_eraro (8);
	k = 32;
	while (((linio [*pozicio]) & k) != 0) k /= 2;
	switch (k) {
		case 32:
			k = 2;
			break;
		
		case 16:
			k = 3;
			break;
		
		case 8:
			k = 4;
			break;
		
		case 4:
			k = 5;
			break;
		
		case 2:
			k = 6;
			break;
	};
	l = (unsigned long) ((linio [*pozicio]) & (255 >> k));
	k = (*pozicio) + k;
	(*pozicio) ++;
	while (k != (*pozicio)) {
		if ((linio [*pozicio]) >> 6 != 2) interp_eraro (8);
		l *= 64;
		l += (unsigned long) ((linio [*pozicio]) & 63);
	 	(*pozicio) ++;
	};
	return l;
}


/*
*	Функция "interp_preni_nomon" считывает из строки "linio" имя,
*	первая буква которого начинается с позиции "*pozicio".
*	
*	Буквы, допустимые в качестве составляющих имени, представляют собой
*	NameStartChar из стандарта XML1.1, а также цифры "0" - "9".
*	
*	Возвращаемым значением функции является ссылка на массив чисел типа
*	(unsigned long), составленный из номеров букв имени в таблице юникода,
*	и дополнительной цифры 0 в конце.
*	
*	По окончании работы функции значением параметра "*pozicio" является
*	номер позиции, непосредственно следующей за считанным именем.
*
*/

unsigned long *interp_preni_nomon (char *linio, int *pozicio) {
	int k = 0;
	unsigned long *nomo;
	unsigned long l;
	
	nomo = (unsigned long *) malloc (sizeof (unsigned long) * NOM_LIM);
	if (nomo == NULL) ref_eraro (1);
	do {
		l = interp_preni_literon (linio, pozicio);
		if (((l > 47)  && (l < 59)) || ((l > 64) && (l < 91)) ||
		(l == 95) || ((l > 96) && (l < 123)) ||
		((l > 191) && (l < 215)) || ((l > 215) && (l < 247)) ||
		((l > 247) && (l < 768)) || ((l > 879) && (l < 894)) ||
		((l > 894) && (l < 8192)) || (l == 8204) || (l == 8205) ||
		((l > 8303) && (l < 8592)) || ((l > 11263) && (l < 12272)) ||
		((l > 12288) && (l < 55296)) || ((l > 63743) && (l < 64976)) ||
		((l > 65007) && (l < 65534)) || ((l > 65535) && (l < 983038))) {
			nomo [k] = l;
			k ++;
		}
		else {
			nomo [k] = 0;
			k = 0;
		};
	} while (k != 0);
	if (nomo [0] == 0) interp_eraro (9);
	do {
		(*pozicio) --;
	} while ((linio [*pozicio]) >> 6 == 2);
	return nomo;
}


/*
*	Функция "interp_preteriri_spacetojn" заменяет значение параметра "*pozicio"
*	на ближайшее к нему справа начало буквы, отличной от пробела и символа
*	табуляции. Если исходное значение параметра само не являлось началом
*	пробела или символа табуляции, оно не изменяется.
*
*/

void interp_preteriri_spacetojn (char *linio, int *pozicio) {
	int i;
	unsigned long l;
	
	do {
		l = interp_preni_literon (linio, pozicio);
		if ((l == 9) || (l == 32)) {
			i = 1;
		}
		else {
			i = 0;
		};
	} while (i);
	do {
		(*pozicio) --;
	} while ((linio [*pozicio]) >> 6 == 2);
	return;
}


/*
*	Функция "interp_kompari_nomojn" сравнивает массивы "nom1" и "nom2"
*	(не далее, чем до первого вхождения числа 0 в один из массивов!).
*	Если массивы равны, возвращаемым значением функции является 1.
*	Иначе таковым является 0.
*
*/

int interp_kompari_nomojn (unsigned long *nom1, unsigned long *nom2) {
	int i = 1, k = -1;
	
	do {
		k ++;
		if (nom1 [k] != nom2 [k]) i = 0;
	} while (i && (nom1 [k] != 0) && (nom2 [k] != 0));
	if (i) return 1;
	return 0;
}


/*
*	Функция "interp_preni_nombron" считывает число, чья вторая (!) цифра
*	записана в строке "linio" в позиции "*pozicio". Считанное число
*	записывается между левой литероидной скобкой "lasta->ant"
*	и соответствующей правой скобкой. При этом предполагается, что
*	перед началом работы функции первая цифра считываемого числа уже записана
*	по адресу "lasta->dat.cif".
*	
*	По окончании работы функции значением параметра "*pozicio" является
*	номер позиции, непосредственно следующей за считанным числом.
*
*/

void interp_preni_nombron (char *linio, int *pozicio, LITERO *lasta) {
	unsigned long l, m;
	LITERO *kuranta;
	
	l = interp_preni_literon (linio, pozicio);
	while ((l > 47) && (l < 58)) {
		kuranta = lasta;
		m = (kuranta->dat.cif) * 10 + l - 48;
		kuranta->dat.cif = m % 65536;
		m /= 65536;
		kuranta = kuranta->sekv;
		while (ESTAS_CIFER (kuranta)) {
			m += (kuranta->dat.cif) * 10;
			kuranta->dat.cif = m % 65536;
			m /= 65536;
			kuranta = kuranta->sekv;
		};
		if (m != 0) {
			krei_literon ((kuranta->ant)->sekv);
			((kuranta->ant)->sekv)->ant = kuranta->ant;
			ligi_literojn ((kuranta->ant)->sekv, kuranta);
			(kuranta->ant)->tip = CIFER;
			(kuranta->ant)->dat.cif = m;
		};
		l = interp_preni_literon (linio, pozicio);
	};
	do {
		(*pozicio) --;
	} while ((linio [*pozicio]) >> 6 == 2);
	return;
}


/*
*	Функция "interp_sercxi_duonagemajn" находит 'полуактивные' e-переменные
*	в непустом образце.
*
*/

void interp_sercxi_duonagemajn () {
	int i;
	LITERO *kuranta, *kuranta1;
	
	kuranta = KFS->mod;
	while (!ESTAS_KONK_P (kuranta)) {
		switch (kuranta->tip) {
			case MD_LIT_PARENT:
				kuranta = kuranta->dat.dual;
				break;
			
			case MD_STR_PARENT:
			case KONK_K:
				kuranta1 = kuranta->dat.dual;
				i = 1;
				while (i) {
					kuranta1 = kuranta1->ant;
					switch (kuranta1->tip) {
						case D_LIT_PARENT:
						case D_STR_PARENT:
							kuranta1 = kuranta1->dat.dual;
							break;
						
						case MD_STR_PARENT:
						case KONK_K:
							i = 0;
							break;
						
						case VAR:
							switch ((kuranta1->dat.var)->tip) {
								case S_AGEM:
								case S_MALAGEM:
								case W_AGEM:
								case W_MALAGEM:
									break;
								
								case E_AGEM:
									(kuranta1->dat.var)->tip =
										E_DUONAGEM;
									i = 0;
									break;
								
								case E_MALAGEM:
									i = 0;
									break;
							};
							break;
					};
				};
				break;
		};
		kuranta = kuranta->sekv;
	};
	return;
}


/*
*	Функция "interp_detrui_funkcion" освобождает память из литер,
*	использованных при описании функции "f".
*
*	ЗАМЕЧАНИЕ: память типа (SUBSTITUO *) не освобождается, что приводит
*	при большом числе переопределений функций к некоторым утечкам :(
*
*/

void interp_detrui_funkcion (FUNKCIO *f) {
	int i;
	LITERO *kuranta_l, *sekva_l;
	SUBSTITUO *kuranta_s;
	
	if ((f->enk == 0) && (f->dat.s != NULL)) {
		kuranta_s = f->dat.s;
		f->dat.s = NULL;
		i = 1;
		do {
			if (kuranta_s->mod != NULL) {
				kuranta_l = kuranta_s->mod;
				while (!ESTAS_KONK_P (kuranta_l)) {
					sekva_l = kuranta_l->sekv;
					detrui_literon (kuranta_l);
					kuranta_l = sekva_l;
				};
				detrui_literon (kuranta_l);
			};
			if (kuranta_s->rez != NULL) {
				kuranta_l = kuranta_s->rez;
				while (kuranta_l->sekv != NULL) {
					sekva_l = kuranta_l->sekv;
					detrui_literon (kuranta_l);
					kuranta_l = sekva_l;
				};
				detrui_literon (kuranta_l);
			};
			kuranta_s = kuranta_s->sekv;
			if (kuranta_s == NULL) {
				i = 0;
			};
		} while (i);
	};
	return;
}

