/*
*	interpretilo2.c - средства для подключения библиотек встроенных функций.
*	© 2005, А.А.Владимиров.
*
*	Данная программа является свободным программным обеспечением.
*	Вы вправе распространять ее и/или модифицировать в соответствии
*	с условиями версии 2, либо, по вашему выбору, с условиями
*	более поздней версии Стандартной Общественной Лицензии GNU,
*	опубликованной Free Software Foundation.
*
*	Мы распространяем данную программу в надежде на то, что она будет вам
*	полезной, однако НЕ ПРЕДОСТАВЛЯЕМ НА НЕЕ НИКАКИХ ГАРАНТИЙ, в том числе
*	ГАРАНТИИ ТОВАРНОГО СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ ИСПОЛЬЗОВАНИЯ
*	В КОНКРЕТНЫХ ЦЕЛЯХ. Для получения более подробной информации ознакомьтесь
*	со Стандартной Общественной Лицензией GNU.
*
*	Вместе с данной программой вы должны были получить экземпляр
*	Стандартной Общественной Лицензии GNU. Если вы его не получили,
*	сообщите об этом в
*	
*	Free Software Foundation, Inc.,
*	59 Temple Place, Suite 330,
*	Boston, MA 02111-1307
*	USA
*
*/

# include "refal.h"


void interp_aldoni_enkonstruitan (char *nomo, void (*funk) (void));


/* ========================================================================== */


extern void ref_eraro (int);
extern unsigned long *interp_preni_nomon (char*, int*);
extern int interp_kompari_nomojn (unsigned long*, unsigned long*);


/* ========================================================================== */


/*
*	Функция "interp_aldoni_enkonstruitan" определяет встроенную функцию,
*	запускающую C-функцию "funk".
*
*/

void interp_aldoni_enkonstruitan (char *nomo, void (*funk) (void)) {
	int i = 0;
	unsigned long *nomo1;
	FUNKCIO *f;
	
	nomo1 = interp_preni_nomon (nomo, &i);
	f = LF;
	do {
		f = f->sekv;
		i = interp_kompari_nomojn (nomo1, f->nom);
	} while (!i && (f->sekv != NULL));
	if (i) {
		f->enk = 1;
		free (nomo1);
		f->dat.f = funk;
	}
	else {
		f->sekv = (FUNKCIO *) malloc (sizeof (FUNKCIO));
		if (f->sekv == NULL) ref_eraro (1);
		f = f->sekv;
		f->enk = 1;
		f->nom = nomo1;
		f->dat.f = funk;
		f->sekv = NULL;
	};
	return;
}


