/*
*	masxino.c - наиболее общие функции рефал-машины.
*	© 2005, А.А.Владимиров.
*
*	Данная программа является свободным программным обеспечением.
*	Вы вправе распространять ее и/или модифицировать в соответствии
*	с условиями версии 2, либо, по вашему выбору, с условиями
*	более поздней версии Стандартной Общественной Лицензии GNU,
*	опубликованной Free Software Foundation.
*
*	Мы распространяем данную программу в надежде на то, что она будет вам
*	полезной, однако НЕ ПРЕДОСТАВЛЯЕМ НА НЕЕ НИКАКИХ ГАРАНТИЙ, в том числе
*	ГАРАНТИИ ТОВАРНОГО СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ ИСПОЛЬЗОВАНИЯ
*	В КОНКРЕТНЫХ ЦЕЛЯХ. Для получения более подробной информации ознакомьтесь
*	со Стандартной Общественной Лицензией GNU.
*
*	Вместе с данной программой вы должны были получить экземпляр
*	Стандартной Общественной Лицензии GNU. Если вы его не получили,
*	сообщите об этом в
*	
*	Free Software Foundation, Inc.,
*	59 Temple Place, Suite 330,
*	Boston, MA 02111-1307
*	USA
*
*/

# include "refal.h"
# include <libintl.h>


void ref_lancxi (void);
void ref_cxesigi (void);
void ref_eraro (int);


void ref_forfroti (void);
int ref_konkretigi (void);


/* ========================================================================== */


extern int ref_alfronti (void);
extern void ref_substitui (void);


/* ========================================================================== */


/*
*	Функция "ref_lancxi" осуществляет пошаговую работу рефал-машины.
*
*/

void ref_lancxi () {
	int i;
	
	do {
		KKP = LKP->dat.dual;
		KKK = KKP->dat.dual;
		LKP = LKP->sekv;
		detrui_literon (LKP->ant);
		i = ref_konkretigi ();
		ref_forfroti ();
	} while (i);
	return;
}


/*
*	Функция "ref_cxesigi" представляет собой пустую функцию, используемую
*	в процессе остановки рефал-машины.
*
*/

void ref_cxesigi () {
	
	return;
}


/*
*	Функция "ref_eraro" генерирует сообщения об ошибках работы рефал-машины.
*
*/

void ref_eraro (int ern) {
	
	switch (ern) {
		case 1:
			fprintf (stderr, "\n%s: %s.\n", gettext ("Eraro"),
			gettext ("eraro dum prenado memoron"));
			break;
		
		case 2:
			fprintf (stderr, "\n%s: %s.\n", gettext ("Eraro"),
			gettext ("malbona sekvenco de bajtoj"));
			break;

		case 3:
			fprintf (stderr, "\n%s: %s.\n", gettext ("Eraro"),
			gettext ("alfrontado estas neebla"));
			break;

		case 5:
			fprintf (stderr, "\n%s: %s.\n", gettext ("Eraro"),
			gettext ("tro longa linio"));
			break;

		case 6:
			fprintf (stderr, "\n%s: %s.\n", gettext ("Eraro"),
			gettext ("apliko je sendeterminita funkcio"));
			break;
			
		case 7:
			fprintf (stderr, "\n%s: %s.\n", gettext ("Eraro"),
			gettext ("malbona sekvenco de UTF-8"));
			break;

		case 8:
			fprintf (stderr, "\n%s: %s.\n", gettext ("Eraro"),
			gettext ("apliko je enkonstruita funkcio estas neebla"));
			break;

		default:
			fprintf (stderr, "\n%s: %s.\n", gettext ("Eraro"),
			gettext ("nerekonita eraro"));
			break;
	}
	exit (0);
	return;
}


/* ========================================================================== */


/*
*	Функция "ref_forfroti" 'стирает' конкретизационный символ "k" и
*	конкретизационную точку, отвечающие 'отработанной' конкретизации.
*
*/

void ref_forfroti () {

	if (KKK->sekv == KKP) {	
		ligi_literojn (KKK->ant, KKP->sekv);
	}
	else {
		ligi_literojn (KKK->ant, KKK->sekv);
		ligi_literojn (KKP->ant, KKP->sekv);
	};
	detrui_literon (KKP);
	detrui_literon (KKK);
	return;
}


/*
*	Функция "ref_konkretigi" запускает процесс конкретизации.
*
*/

int ref_konkretigi () {
	int i, j = 1;
	
	if ((KKK->dat.funk)->enk) {
		(*((KKK->dat.funk)->dat.f)) ();
	}
	else {
		KFS = (KKK->dat.funk)->dat.s;
		if (KFS == NULL) ref_eraro (6);
		while (j) {
			i = ref_alfronti ();
			if (i) {
				ref_substitui ();
				j = 0;
			}
			else {
				if (KFS->sekv == NULL) ref_eraro (3);
				KFS = KFS->sekv;
			};
		};
	};
	if (KKK->dat.funk == LF) {
		return 0;
	}
	else {
		return 1;
	};
}

