/*
*	masxino1.c - подробное определение рефал-машины.
*	© 2005, А.А.Владимиров.
*
*	Данная программа является свободным программным обеспечением.
*	Вы вправе распространять ее и/или модифицировать в соответствии
*	с условиями версии 2, либо, по вашему выбору, с условиями
*	более поздней версии Стандартной Общественной Лицензии GNU,
*	опубликованной Free Software Foundation.
*
*	Мы распространяем данную программу в надежде на то, что она будет вам
*	полезной, однако НЕ ПРЕДОСТАВЛЯЕМ НА НЕЕ НИКАКИХ ГАРАНТИЙ, в том числе
*	ГАРАНТИИ ТОВАРНОГО СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ ИСПОЛЬЗОВАНИЯ
*	В КОНКРЕТНЫХ ЦЕЛЯХ. Для получения более подробной информации ознакомьтесь
*	со Стандартной Общественной Лицензией GNU.
*
*	Вместе с данной программой вы должны были получить экземпляр
*	Стандартной Общественной Лицензии GNU. Если вы его не получили,
*	сообщите об этом в
*	
*	Free Software Foundation, Inc.,
*	59 Temple Place, Suite 330,
*	Boston, MA 02111-1307
*	USA
*
*/

# include "refal.h"


LITERO* al [2];

int ref_alfronti (void);
void ref_substitui (void);


int ref_retirigxi (void);
int ref_kompari (VARIABLO*);
LITERO *ref_kopii (LITERO*, LITERO*, LITERO*);
void ref_stringi (void);
void ref_klarigi (void);


/* ========================================================================== */

extern void ref_eraro (int);


/* ========================================================================== */


/*
*	Функция "ref_alfronti" сопоставляет выражение, заключённое между KKK и KKP,
*	с образцом, заключённым между KFS->mod и (KFS->mod)->dat.dual.
*	
*	В случае возможности сопоставления, возвращаемым значением функции
*	является 1. При этом значениями элементов "ant" и "sekv" в описаниях
*	переменных сопоставляемого образца оказываются те, которые отвечают
*	самому левому варианту сопоставления.
*
*	В случае невозможности сопоставления возвращаемым значением является 0.
*	
*/

int ref_alfronti () {
	LITERO *kuranta;
	VARIABLO *v;
	int i;
	
	al [0] = KKK->sekv;
	al [1] = (KFS->mod)->sekv;
	while (1) {
		switch ((al [1])->tip) {
			case CIFER:
				if (ESTAS_CIFER (al [0])) {
					if ((al [0])->dat.cif == (al [1])->dat.cif) {
						al [0] = (al [0])->sekv;
						al [1] = (al [1])->sekv;
					}
					else {
						i = ref_retirigxi ();
						if (!i) return 0;
					};
				}
				else {
					i = ref_retirigxi ();
					if (!i) return 0;
				};
				break;
				
			case MD_LIT_PARENT:
			case D_LIT_PARENT:
			case MD_STR_PARENT:
			case D_STR_PARENT:
				if ((al [0])->tip == (al [1])->tip) {
					al [0] = (al [0])->sekv;
					al [1] = (al [1])->sekv;
				}
				else {
					i = ref_retirigxi ();
					if (!i) return 0;
				};
				break;
				
			case KONK_P:
				if (al [0] == KKP) {
					return 1;
				}
				else {
					i = ref_retirigxi ();
					if (!i) return 0;
				};
				break;
				
			case VAR:
				v = (al [1])->dat.var;
				switch (v->tip) {
					case S_MALAGEM:
					case W_MALAGEM:
					case E_MALAGEM:
						v->ant = (al [0])->ant;
						i = ref_kompari (v->ref);
						if (i) {
							v->sekv = al [0];
						}
						else {
							i = ref_retirigxi ();
							if (!i) return 0;
						};
						break;
					
					case S_AGEM:
						if (ESTAS_MD_LIT_PARENT (al [0])) {
							v->ant = (al [0])->ant;
							v->sekv = ((al [0])->dat.dual)->sekv;
							al [0] = v->sekv;
							al [1] = (al [1])->sekv;
						}
						else {
							i = ref_retirigxi ();
							if (!i) return 0;
						};
						break;

					case W_AGEM:
						if (ESTAS_MD_LIT_PARENT (al [0]) ||
						ESTAS_MD_STR_PARENT (al [0])) {
							v->ant = (al [0])->ant;
							v->sekv = ((al [0])->dat.dual)->sekv;
							al [0] = v->sekv;
							al [1] = (al [1])->sekv;
						}
						else {
							i = ref_retirigxi ();
							if (!i) return 0;
						};
						break;

					case E_AGEM:
						v->ant = (al [0])->ant;
						v->sekv = al [0];
						al [1] = (al [1])->sekv;
						break;
					
					case E_DUONAGEM:
						v->ant = (al [0])->ant;
						kuranta = al [1];
						while ((!ESTAS_MD_STR_PARENT (kuranta)) &&
						(!ESTAS_KONK_K (kuranta))) {
							if (ESTAS_D_LIT_PARENT (kuranta) ||
							ESTAS_D_STR_PARENT (kuranta)) {
								kuranta = kuranta->dat.dual;
								al [0] = (al [0])->dat.dual;
							};
							if (ESTAS_VAR (kuranta)) {
								al [0] =
									((kuranta->dat.var)->ant)->sekv;
							};
							kuranta = kuranta->ant;
							al [0] = (al [0])->ant;
						};
						kuranta = kuranta->dat.dual;
						if (ESTAS_KONK_K (al [0])) {
							al [0] = KKP;
						}
						else {
							al [0] = (al [0])->dat.dual;
						};
						i = 1;
						while (i) {
							kuranta = kuranta->ant;
							al [0] = (al [0])->ant;
							if (ESTAS_D_LIT_PARENT (kuranta) ||
							ESTAS_D_STR_PARENT (kuranta)) {
								if (((al [0])->tip != kuranta->tip) ||
								(al [0] == v->ant)) {
									i = ref_retirigxi ();
									if (!i) return 0;
									i = 0;
								}
								else {
									kuranta = kuranta->dat.dual;
									al [0] = al [0]->dat.dual;
								};
							};
							if (ESTAS_VAR (kuranta)) {
								if (kuranta == al [1]) {
									v->sekv = (al [0])->sekv;
									al [0] = (al [0])->sekv;
									al [1] = (al [1])->sekv;
									i = 0;
								}
								else {
									if (((!ESTAS_D_LIT_PARENT (al [0]))
									&& (!ESTAS_D_STR_PARENT (al [0])))
									|| (al [0] == v->ant)) {
										i = ref_retirigxi ();
										if (!i) return 0;
										i = 0;
									}
									else {
										al [0] = (al [0])->dat.dual;
									};
								};
							};
						};
						break;
				};
				break;
		};
	};
	return 0;
}


/*
*	Функция "ref_substitui" заменяет выражение, заключённое между KKK и KKP,
*	выражением, получаемым в результате подстановки в правую часть
*	KFS->rez соответствующих значений переменных из образца KFS->mod.
*
*	При этом также заменяется список конкретизаций: если правая часть KFS->rez
*	(а тогда и вставляемое выражение) содержит конкретизации, то ссылки
*	на соответствующие конкретизационные точки вставляются перед текущим LKP.
*	
*	# Ссылки "ant" в литерах из правой части KFS->rez не используются
*	# по прямому назначению. Это позволяет применять их в качестве буфера.
*	# Такая возможность действительно используется в функции "ref_substitui".
*
*/

void ref_substitui () {
	LITERO *bufro, *kuranta_esp, *kuranta_rez, *kuranta_lkp, *unua, *lasta;
	VARIABLO *v;

	ref_stringi ();
	krei_literon (bufro);
	ligi_literojn (bufro, KKK->sekv);
	bufro->ant = NULL;
	kuranta_esp = KKK;
	kuranta_rez = KFS->rez;
	kuranta_lkp = LKP;
	
	while (kuranta_rez != NULL) {
		switch (kuranta_rez->tip) {
			case CIFER:
				krei_literon (bufro);
				ligi_literojn (kuranta_esp, bufro);
				kuranta_esp = bufro;
				kuranta_esp->tip = CIFER;
				kuranta_esp->dat.cif = kuranta_rez->dat.cif;
				break;
			
			case MD_LIT_PARENT:
				krei_literon (bufro);
				ligi_literojn (kuranta_esp, bufro);
				kuranta_esp = bufro;
				kuranta_esp->tip = MD_LIT_PARENT;
				krei_literon (bufro);
				ligi_parentezojn (kuranta_esp, bufro);
				bufro->tip = D_LIT_PARENT;
				(kuranta_rez->dat.dual)->ant = bufro;
				break;
			
			case D_LIT_PARENT:
				ligi_literojn (kuranta_esp, kuranta_rez->ant);
				kuranta_esp = kuranta_esp->sekv;
				break;
			
			case MD_STR_PARENT:
				krei_literon (bufro);
				ligi_literojn (kuranta_esp, bufro);
				kuranta_esp = bufro;
				kuranta_esp->tip = MD_STR_PARENT;
				krei_literon (bufro);
				ligi_parentezojn (kuranta_esp, bufro);
				bufro->tip = D_STR_PARENT;
				(kuranta_rez->dat.dual)->ant = bufro;
				break;
			
			case D_STR_PARENT:
				ligi_literojn (kuranta_esp, kuranta_rez->ant);
				kuranta_esp = kuranta_esp->sekv;
				break;
			
			case KONK_K:
				krei_literon (bufro);
				ligi_literojn (kuranta_esp, bufro);
				kuranta_esp = bufro;
				kuranta_esp->tip = KONK_K;
				kuranta_esp->dat.funk = kuranta_rez->dat.funk;
				krei_literon (bufro);
				bufro->tip = KONK_P;
				bufro->dat.dual = kuranta_esp;
				kuranta_rez->ant = bufro;
				break;
			
			case KONK_P:
				ligi_literojn (kuranta_esp, (kuranta_rez->dat.dual)->ant);
				kuranta_esp = kuranta_esp->sekv;
				krei_literon (bufro);
				if (kuranta_lkp == LKP) {
					LKP = bufro;
				}
				else {
					ligi_literojn (kuranta_lkp->ant, bufro);
				};
				ligi_literojn (bufro, kuranta_lkp);
				bufro->dat.dual = kuranta_esp;
				break;
			
			case VAR:
				v = kuranta_rez->dat.var;
				if ((v->ref)->ant != NULL) {
					unua = (v->ref)->ant;
					lasta = (v->ref)->sekv;
					if (ESTAS_S_AGEM (v) || ESTAS_W_AGEM (v) ||
					ESTAS_E_AGEM (v)) {
						kuranta_esp = ref_kopii
							(unua, lasta, kuranta_esp);
					}
					else {
						ligi_literojn (unua->ant, lasta->sekv);
						ligi_literojn (kuranta_esp, unua);
						kuranta_esp = lasta;
					};
				};
				break;
			
			default:
				ref_eraro (-1);
				break;
		};
		kuranta_rez = kuranta_rez->sekv;
	};
	ref_klarigi ();
	ligi_literojn (kuranta_esp, KKP);
	return;
}


/* ========================================================================== */


/*
*	Функция "ref_retirigxi" производит откат к ближайшей слева
*	'активной' e-переменной, чьё значение может быть удлинено на терм.
*	Начальное состояние процесса отката определяется значением "al [1]".
*	
*	В случае неуспеха процедуры возвращаемым значением функции является 0.
*	Иначе таковым значением будет 1, причём:
*	
*	1) Ближайшая слева к начальному состоянию 'активная' e-переменная,
*	допускающая удлинение, удлиняется на терм;
*	2) Значением "al [1]" становится первая литера после этой переменной;
*	3) Значением "al [0]" становится первая литера после нового значения
*	этой переменной.
*
*/

int ref_retirigxi () {
	VARIABLO *v;
	
	while (1) {
		al [1] = (al [1])->ant;
		switch ((al [1])->tip) {
			case KONK_K:
				return 0;
				break;
			
			case VAR:
				v = (al [1])->dat.var;
				if (ESTAS_E_AGEM (v) && (ESTAS_MD_LIT_PARENT (v->sekv) ||
				ESTAS_MD_STR_PARENT (v->sekv))) {
					v->sekv = ((v->sekv)->dat.dual)->sekv;
					al [0] = v->sekv;
					al [1] = (al [1])->sekv;
					return 1;
				};
				break;
			
			default:
				break;
		};
	};
	return 0;
}


/*
*	Функция "ref_kompari" сравнивает подсписок, первой литерой которого
*	является "al [0]", со значением переменной "v". Если вышеуказанный список
*	не содержит в своём начале копии значения вышеуказанной переменной, то
*	возвращаемым значением функции будет 0. Иначе таковым значением
*	будет 1, причём:
*	
*	1) Значение "al [1]" будет заменено на значение "(al [1])->sekv";
*	2) Значением "al [0]" будет первая литера после вышеописанной копии
*	значения переменной "v".
*
*/

int ref_kompari (VARIABLO *v) {
	LITERO *vidata, *halto;
	
	vidata = (v->ant)->sekv;
	halto = v->sekv;
	while (1) {
		if (vidata == halto) {
			al [1] = (al [1])->sekv;
			return 1;
		};
		if ((al [0])->tip == vidata->tip) {
			if ((al [0])->tip == CIFER) {
				if ((al [0])->dat.cif != vidata->dat.cif) return 0;
			};
		}
		else {
			return 0;
		}
		vidata = vidata->sekv;
		al [0] = (al [0])->sekv;
	};
	return 0;
}


/*
*	Функция "ref_kopii" копирует участок списка, расположенный между "unua" и
*	"lasta" (включая эти две литеры), и 'приклеивает' копию после "esp".
*	
*	Возвращаемым значением функции является ссылка на последнюю литеру
*	'приклеенной' копии.
*
*/

LITERO *ref_kopii (LITERO *unua, LITERO *lasta, LITERO *esp) {
	LITERO *sekva, *kuranta, *vidata;
	
	vidata = unua;
	kuranta = esp;
	while (1) {
		krei_literon (sekva);
		ligi_literojn (kuranta, sekva);
		kuranta = sekva;
		kuranta->tip = vidata->tip;
		switch (kuranta->tip) {
			case CIFER:
				kuranta->dat.cif = vidata->dat.cif;
				break;
			
			case MD_LIT_PARENT:
				vidata->dat.dual = kuranta;
				break;
			
			case D_LIT_PARENT:
				ligi_parentezojn ((vidata->dat.dual)->dat.dual, kuranta);
				(vidata->dat.dual)->dat.dual = vidata;
				break;
			
			case MD_STR_PARENT:
				vidata->dat.dual = kuranta;
				break;
			
			case D_STR_PARENT:
				ligi_parentezojn ((vidata->dat.dual)->dat.dual, kuranta);
				(vidata->dat.dual)->dat.dual = vidata;
				break;
		};
		if (vidata == lasta) {
			return kuranta;
		}
		else {
			vidata = vidata->sekv;
		};
	};
	return kuranta;
}


/*
*	Функция "ref_stringi" 'сдвигает' ссылки "( ->dat.var)->ant" и
*	"( ->dat.var)->sekv" для всех переменных из образца "KFS->mod"
*	на одну позицию 'внутрь' значения переменной. Для e-переменных
*	с пустыми значениями в качестве нового значения элемента
*	"( ->dat.var)->ant" устанавливается "NULL".
*
*	# ПРИМЕР: Рассмотрим образец
*	#
*	#		KONK_K s/1/ ( e/2/ ) e/3/ KONK_P,
*	#
*	# сопоставляемый с выражением
*	#
*	#		KONK_K a ( ) b c d KONK_P
*	#		1      2 3 4 5 6 7 8.
*	#
*	# Исходными значениями будут:
*	# (s/1/->dat.var)->ant = 1,	(s/1/->dat.var)->sekv = 3,
*	# (e/2/->dat.var)->ant = 3,	(e/2/->dat.var)->sekv = 4,
*	# (e/3/->dat.var)->ant = 4,	(e/3/->dat.var)->sekv = 8.
*	#
*	# Новыми значениями будут:
*	# (s/1/->dat.var)->ant = 2,	(s/1/->dat.var)->sekv = 2,
*	# (e/2/->dat.var)->ant = NULL,
*	# (e/3/->dat.var)->ant = 5,	(e/3/->dat.var)->sekv = 7.
*
*/

void ref_stringi () {
	LITERO *kuranta;
	VARIABLO *v;
	
	kuranta = KFS->mod;
	while (!ESTAS_KONK_P (kuranta)) {
		if (ESTAS_VAR (kuranta)) {
			v = kuranta->dat.var;
			if ((v->ant)->sekv == v->sekv) {
				v->ant = NULL;
			}
			else {
				v->ant = (v->ant)->sekv;
				v->sekv = (v->sekv)->ant;
			};
		};
		kuranta = kuranta->sekv;
	};
	return;
}


/*
*	Функция "ref_klarigi" освобождает память из неиспользованных
*	при построении нового поля зрения частей исходного поля зрения.
*
*/

void ref_klarigi () {
	LITERO *kuranta;
	
	kuranta = KKP->ant;
	while (kuranta->ant != NULL) {
		detrui_literon (kuranta);
		kuranta = kuranta->ant;
	};
	detrui_literon (kuranta);
	return;
}


